def checkProductionModel():

	#If the production model or gateway is restarted, then we might be calling mes functions that are not ready for us.
	#This function returns the state of the production model runner thread
	
	try:
		prodModelState = system.mes.getProductionModelRunnerState()
		running = prodModelState.isRunning()
	except:
		running = False

	return running
#########################################################################
def convertSQLTimeStamp(timeStamp):

	#Sepasoft functions have a habit of sometimes returning a java.util.date object and sometimes a SQL Timestamp object, whereas
	#they always want to receive a java.util.date object. This function will take a java.util.date or sql.timestamp object and 
	#return a java.util.date object
	 	
	if timeStamp is None:
		return timeStamp	 	
	 	
	from java.util import Calendar
	cal = Calendar.getInstance()
	cal.setTimeInMillis(timeStamp.getTime()) #Convert it to a java.util.Calendar object
	utilDate = cal.getTime() #and then to a java.util.date object

	return utilDate	
#########################################################################
def fixLine(linePath):
	system.mes.invalidateCache()
	print linePath
	activeOperations = system.mes.getCurrentOperations(linePath)
	for op in activeOperations:
		op.abort()
	fixList = ["Equipment Operation UUID", "Equipment Product Code", "Equipment Work Order", "Equipment Mode"]
	 
	lineObjLink = system.mes.getMESObjectLink(system.mes.loadMESObjectByEquipmentPath(linePath).UUID)
	childList = []
	
	return	
#########################################################################	
def printDataset(data):
	
		#Given a dataset, this functions prints out its contents
	
		columns = data.getColumnNames()
		print list(columns)
		pds = system.dataset.toPyDataSet(data)
		for row in pds:
			strs = ''
			for value in row:
				strs += str(value) + "	"
			
			print strs	

#########################################################################			
def exportToExcel(data, fileName, launch):
		
	#This function takes data, filename and whether to open if excel or not

#	if fileName.find('.xls') == -1:
#		fileName = fileName + ".xls"

	filePath = system.dataset.exportExcel(fileName, 1, data)

	if launch and filePath is not None:
		filePath = filePath.replace('\\','/')
		filePath = filePath.replace(' ','%20')
		system.net.openURL("file:///"+filePath)	
#########################################################################	
def getContrastingColor(hexColor):

	'''
	Input a string of RGB hex digits with hash sign to compute complementary contrasting color such as for fonts
	'''
	hexColor = hexColor.replace('#','')
	
	(r, g, b) = (hexColor[:2], hexColor[2:4], hexColor[4:])
	return '#000000' if 1 - (int(r, 16) * 0.299 + int(g, 16) * 0.587 + int(b, 16) * 0.114) / 255 < 0.5 else '#FFFFFF'
#########################################################################

def getHEXColor(name):

	colorData = system.tag.read("Configuration/Styles/stylesColor").value
	displayColor = '255,255,255'	#default in case we don't find this style

	if name is not None:	
		for rowIndex in range(colorData.rowCount):
			if name.upper() == colorData.getValueAt(rowIndex,0).upper():
				displayColor = colorData.getValueAt(rowIndex,1)
				break	
	
	rgb = displayColor.split(',')			
	displayColor = shared.Kanoa.Utilities.RGBtoHex(rgb[0],rgb[1],rgb[2])	
				
	return displayColor.upper()
#############################################################################	
def getStyleColor(name):		

	#This function will return a style color for the given name. Name could be a mode or a state 

	colorData = system.tag.read("Configuration/Styles/stylesColor").value
	styleColor = '226,226,226'	#Grey (default) in case we don't find this style
		
	for row in range(colorData.rowCount):
		if name.upper() == colorData.getValueAt(row,0).upper():
			styleColor = colorData.getValueAt(row,1)
			break
		
	return styleColor	
#########################################################################	
def RGBtoHex(red,green,blue):

	#Converts RGB color value to HEX value
	
	return '#%02x%02x%02x' % (int(red),int(green),int(blue))
#########################################################################	
def HexToRGB(hexNumber):

	#Converts HEX value to RGB color value

	h = hexNumber.lstrip('#')
	try:
		rgb = tuple(int(h[i:i+2], 16) for i in (0, 2, 4))
	except:
		rgb = (255,255,255)
		
	return rgb
#########################################################################
def ColorToHex(color):

	#Converts RGB colorto HEX value
	
	red = color.getRed()
	green = color.getGreen()
	blue = color.getBlue()	
	
	newColor = '#%02x%02x%02x' % (red,green,blue)
	
	return newColor.upper()
#########################################################################	
def generateHexColor():

	import random
	random_number = random.randint(0,16777215)
#	hex_number = str(hex(random_number))
#	hex_number ='#'+ hex_number[2:]
	hex_number = str(hex(random_number))[2:]
	hex_number ='#'+ hex_number.zfill(6)
	
	return hex_number	
#########################################################################	
def getEquipmentObjects(eqPath, objType):
	
	#This function will return all equipment objects given a path and can also be used to get a count of the number of lines in an area or at a site

	#Create a filter.
	filter = system.mes.object.filter.createFilter()
	  
	filter.setEnableStateName('ENABLED')
	filter.setMESObjectTypeName(objType)
	filter.setMESObjectNamePattern('*')
	filter.setPrimaryMESObjectPath(eqPath)
	
	results = system.mes.loadMESObjects(filter)
	return results	
#########################################################################	
def getEquipmentPaths(parentPath, objType):
	
	#This function will return a list of equipment paths given a parent path, object type and can also be used to get a count of the number of lines in an area or at a site

	objList = shared.Kanoa.Utilities.getEquipmentObjects(parentPath, objType)
	
	eqList = []
	
	for item in objList:
		eqList.append(item.getEquipmentPath())
		
	eqList.sort()			
	
	return eqList	
#########################################################################
def convertHeaderToHTML(hdrTable):
	
	#This function will take a list of equipment paths and convert it into html that allows for breaks. Nice for showing in a power table 	
	
	newHdrTable = []
	for element in hdrTable:
		try:
			pathList = element.split('\\')
			site = pathList[1] 
			if len(pathList) == 4:
				area = '<br>' + pathList[2]
				line = '<br>' + pathList[3]
			else:
				area = ''
				line = ''
			
			newHdrTable.append('<html><center>' + site + area + line + '</center></html>')
		except:
			newHdrTable.append('<html><center>' + element + '</center></html>')
	
	return newHdrTable
#########################################################################
def getItemFromEqPath(linePath, item):
	
	#This function will return the item whether 'Site', 'Area' or 'Line'. It does not deal with cell groups or cells as those are not in a fixed postion
	
	linePath = linePath.replace('[global]\\','')
	pathList = linePath.split("\\")
	
	itemList = ['ENTERPRISE','SITE','AREA','LINE']
		
	try:
		return pathList[itemList.index(item.upper())]
	except:
		return None
#########################################################################
def getItemPathFromEqPath(eqPath, item):
	
	#This function will return the itemPath whether 'Site', 'Area' or 'Line'. It does not deal with cell groups or cells as those are not in a fixed postion
	
	try:
		eqPath = eqPath.replace('[global]\\','')
		pathList = eqPath.split("\\")
		
		if item.upper() == 'SITE':
			path = pathList[0] + '\\' + pathList[1]
		elif item.upper() == 'AREA':
			path = pathList[0] + '\\' + pathList[1] + '\\' + pathList[2]
		elif item.upper() == 'LINE':
			path = pathList[0] + '\\' + pathList[1] + '\\' + pathList[2] + '\\' + pathList[3]
		else:
			path = None
	
		return path
	except:
		return None			
##########################################################################
def getColor(name):

	#given the name of a mode or state, this function will lookup the color value as we have configured in our styles tag

	import system

	colorData = system.tag.read("Configuration/Styles/stylesColor").value
	styleColor = 'WHITE'	#default in case we don't find this style
		
	for row in range(colorData.rowCount):
		if name.upper() == colorData.getValueAt(row,0).upper():
			styleColor = colorData.getValueAt(row,1)
			break
		
	return styleColor		
###############################################################################
def getLineModeIcon(linePath):

	laPath = shared.Kanoa.Operations.getLiveAnalysisTagPath(linePath) + "/Live Analysis/Run Data"
	modeType = system.tag.read(laPath + "/Equipment Mode Type").value
	if modeType is not None:
		icon = "Kanoa/Modes/" + modeType.lower() + ".png"
	else:
		icon = 'Kanoa/Modes/unknown.png'
		
	return icon
###############################################################################	
def getStyleData(name):

	#Pass in the  name of a mode or a state, this function retunrs the standard color and icon for it

	iconPath = None
	color = "#000000"	#Default it to white

	if name is not None:
		iconPath = 'Kanoa/Modes/unknown.png'	
		data = system.tag.read("Configuration/Styles/stylesColor").value
		for row in range(data.rowCount):
			if data.getValueAt(row, 0) == name.upper():
				color = data.getValueAt(row, 1)
				iconPath = data.getValueAt(row, 2)
				break	
	
	return color, iconPath
###############################################################################	
def getEquipmentModeByClass(equipmentModeClassName):

	hdr = ['Mode Type', 'Mode Name']
	rows = []
	modeList = []

	modeClass = system.mes.loadMESObject(equipmentModeClassName, 'EquipmentModeClass')

	for item in modeClass.getChildCollection().getList():
		obj = item.getMESObject()
		rows.append([obj.getModeTypeName(), obj.getName(),])
	
	rows.append(['UNKNOWN', 'NO MODE DATA'])
	
	data = system.dataset.toDataSet(hdr,rows)
	data = system.dataset.sort(data, 0)
	
	#We can now get a list of mode names ordered by their respective type
	for row in range(data.rowCount):
		modeList.append(data.getValueAt(row,1))
		
	return data, modeList
########################################################################################
def getEqPathType(eqPath):
	
	#This function will return what type the eqPath is for
	#Return value is a string and can be one of the following: LineCell, LineCellGroup, Line, Area, Site, Enterprise

	try:
		objLink = system.mes.getMESObjectLinkByEquipmentPath(eqPath)
	except:
		return None
		
	return objLink.getMESObjectType().getName()	
########################################################################################	
def getChildren(objLink, childList):
	obj = objLink.getMESObject()
	objectLinks = obj.getChildCollection().getList()
	childList.extend(objectLinks)

	for objectLink in objectLinks:
		if objectLink.getMESObjectType().getName() == "LineCellGroup":
			getChildren(objectLink, childList)	
			
	return childList
########################################################################################
def cleanupEquipmentPath(eqPath):

	#Legacy stuff from the productionmodel being in the project scoe and then moved to the global scope between 7.6.4 and 7.6.6, has '[global]\' appended to the equipment path
	#Some mes script functions required the global to be in the name, others didn't. Most mes functions now handle eqPath with or without '[global]\' as a passed parameter, but
	#we are also storing the eqPath in custom tables. This function simply makes sure that whereever the eqPath comes from, it is passed to other functinos with '[global]\' stripped 

	if eqPath is not None:
		eqPath = eqPath.replace('[global]\\','')
	
	return eqPath	
########################################################################################	
def getLineModeClass(eqPath):

	eqPath = shared.Kanoa.Utilities.cleanupEquipmentPath(eqPath) + '%'

	query = """
			SELECT MEMC.Name FROM MESEquipmentModeClass MEMC (NOLOCK)
			JOIN MESEquipment ME on ME.EquipmentModeClassUUID = MEMC.MESEquipmentModeClassUUID 
			JOIN MESObjectLink MOL on MOL.MESObjectUUID = ME.MESEquipmentUUID
			AND ME.Enabled = 1
			AND MOL.MESObjectType = 'Line'
			AND ME.EquipmentPath LIKE ?
			"""
			
	dbName = 'IGN_MES'
	
	modeClass = system.db.runScalarPrepQuery(query, [eqPath], dbName)
	
	return modeClass
#########################################################################
def getObjectList(type, pattern):
	#build a  filter so we can get a list of lines
	objFilter = system.mes.object.filter.createFilter()
	objFilter.setMESObjectTypeName(type)
	objFilter.setMESObjectNamePattern(pattern)	
	objList = system.mes.searchMESObjects(objFilter)
	
	return objList
#########################################################################	
def getMQTTTagPath(eqPath):
	 
	# Given an equipmentPath, this function will return the MQTT tag path
	# eqPath comes in the format of [global]\Enterprise\Site\Area\Line
	# which needs to be converted to "[MQTT Engine]Edge Nodes/Chemical/Taylorsville/ECD/HCHO Incinerator"
	 
	#print "getMQTTTagPath called for ", eqPath
	 
	mqttPath = eqPath
	if mqttPath is not None:
		mqttPath = mqttPath.replace('\\', '/')
		if '[global]/' in (mqttPath):
			mqttPath = mqttPath[len('[global]/'):]    #Remove [global]\
		mqttPath = '[MQTT Engine]Edge Nodes/' + mqttPath
	  
	return mqttPath	
#########################################################################